%define cmucl_ver  18e
%define deb_ver    18e-7
%define clc_ver    3.76
%define release    1

%define distro_release  %(awk '/Fedora/{print $4};/Red Hat/{print $5}' 2>/dev/null </etc/redhat-release)

Summary:      The CMUCL lisp compiler and development system.
Name:         cmucl
Version:      %{cmucl_ver}
Release:      %{?release_prefix:%{release_prefix}.}%{release}%{?release_suffix:.%{release_suffix}}
URL:          ftp://http.us.debian.org/debian/pool/main/c/cmucl
Source0:      cmucl_%{deb_ver}_i386.deb
Source1:      cmucl-docs_%{deb_ver}_all.deb
Source2:      cmucl-source_%{deb_ver}_all.deb
Source10:     common-lisp-controller_%{clc_ver}_i386.deb
# the RedHat 9 dynamic library loader, needed to start cmucl
Patch0:       libdl-2.3.2.so.gz
Copyright:    see /usr/share/doc/cmucl/copyright
Group:        Development/Languages
BuildRoot:    %{_tmppath}/%{name}-%{deb_ver}-root
Requires:     common-lisp-controller >= 3.13
Packager:     Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
Distribution: Planet CCRMA

BuildRequires: alien

%define alienate  alien --to-rpm --generate --scripts

%description
CMUCL is a free implementation of the Common Lisp programming language
which runs on most major Unix platforms. It mainly conforms to the
ANSI Common Lisp standard (http://www.cons.org/cmucl/)

This is the basis package for CMUCL. It contains the base
image with the compiler, PCL (CLOS), and the tty based
debugger.

%package   docs
Summary:   The CMUCL documentation
Copyright: see /usr/share/doc/cmucl-source/copyright
Group:     Development/Languages
Requires:  cmucl == %{cmucl_ver}

%description docs
This is the CMUCL documentation...

%package   source
Summary:   The CMUCL lisp sources
Copyright: see /usr/share/doc/cmucl-source/copyright
Group:     Development/Languages
Requires:  cmucl == %{cmucl_ver}

%description source
These are the CMUCL sources, provided so that the
debugger can show useful source information at appropriate
times.

This version includes common-lisp-controller compatible
replacements for defsystem, graystream, clx and hemlock.

defsystem provides a "make" type system for Lisp. This is
a patched version from clocc.

Gray streams are the usual Lisp streams, but re-implemented
as a Object hierarchy. Users can subclass existing classes and
adapt them for their own needs.

cmucl-clx is the clx library adapted for CMUCL. clx is an
interface to X11, just like xlib.

Hemlock is an emacs clone for CMUCL.

Note that this version only works in X, the tty interface
is broken: the system can't parse /etc/termcap.

To open the editor, type "(ed)".

Note that to recompile CMUCL you need a working CMUCL system :-(

%package -n common-lisp-controller
Version:   %{clc_ver}
Summary:   This is a common lisp source and compiler manager.
Copyright: see /usr/share/doc/common-lisp-controller/copyright
Group:     Development/Languages

%description -n common-lisp-controller
With this package you can install and manage
common lisp sources and compilers and have
a working defsystem system.

%prep

%build
mkdir -p %{_builddir}/%{name}-%{cmucl_ver}
(cd %{_builddir}/%{name}-%{cmucl_ver}; %{alienate} %{SOURCE0})
mkdir -p %{_builddir}/%{name}-%{cmucl_ver}
(cd %{_builddir}/%{name}-%{cmucl_ver}; %{alienate} %{SOURCE1})
mkdir -p %{_builddir}/%{name}-%{cmucl_ver}
(cd %{_builddir}/%{name}-%{cmucl_ver}; %{alienate} %{SOURCE2})
mkdir -p %{_builddir}/%{name}-%{cmucl_ver}
(cd %{_builddir}/%{name}-%{cmucl_ver}; %{alienate} %{SOURCE10})

# create file lists for checking spec file
cd %{_builddir}/%{name}-%{cmucl_ver}/%{name}-%{cmucl_ver}
find . >../%{name}-%{cmucl_ver}.files
cd %{_builddir}/%{name}-%{cmucl_ver}/%{name}-docs-%{cmucl_ver}
find . >../%{name}-docs-%{cmucl_ver}.files
cd %{_builddir}/%{name}-%{cmucl_ver}/%{name}-source-%{cmucl_ver}
find . >../%{name}-source-%{cmucl_ver}.files
cd %{_builddir}/%{name}-%{cmucl_ver}/common-lisp-controller-%{clc_ver}
find . >../common-lisp-controller-%{clc_ver}.files

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
(cd %{_builddir}/%{name}-%{cmucl_ver}/%{name}-%{cmucl_ver}; tar cf - etc usr var) | \
(cd $RPM_BUILD_ROOT; tar xf -)
(cd %{_builddir}/%{name}-%{cmucl_ver}/%{name}-docs-%{cmucl_ver}; tar cf - usr) | \
(cd $RPM_BUILD_ROOT; tar xf -)
(cd %{_builddir}/%{name}-%{cmucl_ver}/%{name}-source-%{cmucl_ver}; tar cf - usr) | \
(cd $RPM_BUILD_ROOT; tar xf -)
(cd %{_builddir}/%{name}-%{cmucl_ver}/common-lisp-controller-%{clc_ver}; tar cf - etc usr) | \
(cd $RPM_BUILD_ROOT; tar xf -)

# create empty lisp configuration file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
echo > $RPM_BUILD_ROOT%{_sysconfdir}/lisp-config.lisp <<EOF
;;; Site cmucl configuration file
EOF

# we do not use the debian menus, remove files
rm -rf $RPM_BUILD_ROOT/usr/lib/menu

# create stub to start cmucl under fc1
%if "%{distro_release}" == "1"
mkdir -p $RPM_BUILD_ROOT/usr/lib/cmucl/lisp/
gzip -d -c %{PATCH0} >$RPM_BUILD_ROOT/usr/lib/cmucl/lisp/libdl-2.3.2.so
mv $RPM_BUILD_ROOT/usr/bin/lisp $RPM_BUILD_ROOT/usr/bin/lisp.bin
cat >$RPM_BUILD_ROOT/usr/bin/lisp <<EOF
#!/bin/bash
# Start CMUCL with preload hack to run under Fedora Core 1
LD_ASSUME_KERNEL=2.2.5 LD_PRELOAD=/usr/lib/cmucl/lisp/libdl-2.3.2.so exec /usr/bin/lisp.bin \$@
EOF
chmod +x $RPM_BUILD_ROOT/usr/bin/lisp
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir /etc/common-lisp
%dir /etc/common-lisp/cmucl
%config /etc/common-lisp/cmucl/site-init.lisp
%dir /var/lib/cmucl
/usr/bin/lisp
%if "%{distro_release}" == "1"
/usr/bin/lisp.bin
/usr/lib/cmucl/lisp
%endif
%dir /usr/lib/cmucl
/usr/lib/cmucl/install-clc.lisp
/usr/lib/cmucl/hemlock11.mask
/usr/lib/cmucl/lisp-dist.core
/usr/lib/cmucl/hemlock11.cursor
/usr/lib/cmucl/include
%dir /usr/lib/common-lisp/bin
/usr/lib/common-lisp/bin/cmucl.sh
/usr/share/doc/cmucl
/usr/share/man/man1/cmucl.1.gz
/usr/share/man/man1/lisp.1.gz
/usr/lib/cmucl/site-init.lisp
%{_sysconfdir}/lisp-config.lisp

%files docs
%defattr(-,root,root)
/usr/share/doc/cmucl-docs

# %post small
# # if [ "$1" = "1" ] ; then
# #   /usr/sbin/register-common-lisp-implementation cmucl-small
# # fi
# if [ -L /usr/lib/cmucl/lisp.core ] ; then
#     rm -f /usr/lib/cmucl/lisp.core
# fi
# if [ ! -e /usr/lib/cmucl/lisp.core ] ; then
#     ln -s /usr/lib/cmucl/lisp-small.core /usr/lib/cmucl/lisp.core
# fi
# if [ ! -L /usr/lib/cmucl/site-init.lisp ] ; then
#     ln -s /etc/common-lisp/cmucl/site-init.lisp /usr/lib/cmucl/site-init.lisp
# fi
# 
# %preun small
# # if [ "$1" = "0" ] ; then
# #   /usr/sbin/unregister-common-lisp-implementation cmucl-small
# # fi
# 
# %postun small
# if [ "$1" = "0" ] ; then
#     if [ -L /usr/lib/cmucl/lisp.core ] ; then
#         link=`ls -l /usr/lib/cmucl/lisp.core | awk '{print $11}'`
#         if [ `basename ${link}` = "lisp-small.core" ] ; then
# 	     rm -f /usr/lib/cmucl/lisp.core
#         fi
#     fi
# fi

%files source
%defattr(-,root,root)
/usr/share/doc/cmucl-source
%dir /usr/share/common-lisp/systems
/usr/share/common-lisp/source

%post source
# if [ "$1" = "1" ] ; then
#   /usr/sbin/register-common-lisp-source cmucl-graystream
#   /usr/sbin/register-common-lisp-source cmucl-clx
#   /usr/sbin/register-common-lisp-source cmucl-hemlock
# fi

%postun source
# if [ "$1" = "0" ] ; then
#   /usr/sbin/unregister-common-lisp-source cmucl-graystream
#   /usr/sbin/unregister-common-lisp-source cmucl-clx
#   /usr/sbin/unregister-common-lisp-source cmucl-hemlock
# fi

%files -n common-lisp-controller
/usr/sbin/register-common-lisp-source
/usr/sbin/unregister-common-lisp-source
/usr/sbin/register-common-lisp-implementation
/usr/sbin/unregister-common-lisp-implementation
/usr/sbin/clc-reregister-all-impl
/usr/sbin/clc-build-daemon
/usr/bin/clc-send-command
/usr/bin/clc-autobuild-library
/usr/bin/clc-autobuild-check
/usr/bin/clc-autobuild-impl
/usr/bin/clc-autobuild-only
/usr/bin/clc-register-user-package
/usr/bin/clc-unregister-user-package
%dir /usr/share/common-lisp/
%dir /usr/share/common-lisp/source/
/usr/share/common-lisp/source/common-lisp-controller
/usr/share/doc/common-lisp-controller
/usr/share/man/man1/clc-unregister-user-package.1.gz
/usr/share/man/man1/clc-send-command.1.gz
/usr/share/man/man1/clc-register-user-package.1.gz
/usr/share/man/man8/clc-reregister-all-impl.8.gz
/usr/share/man/man8/clc-autobuild-only.8.gz
/usr/share/man/man8/clc-autobuild-check.8.gz
/usr/share/man/man8/clc-autobuild-impl.8.gz
/usr/share/man/man8/clc-autobuild-library.8.gz
/usr/share/man/man8/clc-build-daemon.8.gz
/usr/share/man/man8/register-common-lisp-implementation.8.gz
/usr/share/man/man8/unregister-common-lisp-source.8.gz
/usr/share/man/man8/register-common-lisp-source.8.gz
/usr/share/man/man8/unregister-common-lisp-implementation.8.gz
/usr/lib/common-lisp-controller/debug-daemon-problems.sh
%{_sysconfdir}/lisp-config.lisp

%changelog
* Wed Nov 19 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- added again RedHat 9 dynamic library loader to enable cmucl binary
  to start under Fedora Core 1
* Mon Nov 17 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- added empty system configuration file in /etc
* Thu Nov 13 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- added RedHat 9 loader for Fedora Core 1
* Tue Nov  4 2003 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- updated to cmucl 18e-7 and common-lisp-controller 3.76 from debian

* Thu Dec 19 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- updated to cmucl 3.1.4 from debian testing
- updated descriptions from debian descriptions
- redid all file lists, fixed wrong postun scripts, added
  registration and unregistration to cores and source scripts
- latter: reg and unreg does not seem to work correctly, will
  debug in a latter version, for now commented out the calls

* Sat Jun  8 2002 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- updated to cmucl 3.0.9 from debian testing
  ftp://ftp.us.debian.org/debian/pool/main/c/cmucl/

* Thu Sep  6 2001 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu>
- Downloaded 3.0.3 debian packages from:
  ftp://http.us.debian.org/debian/pool/main/c/cmucl
- use alien to extract binaries, create this spec file based
  on the extracted spec files for all packages
